for i = 1, 7
freeslot("S_MAGICSPARK"..i, "SPR_MSPK", "SPR_MMTM", "S_MAGICPANEL"..i, "MT_ICECUBE", "S_ICECUBE", "S_ICECUBEWALL"..i, "SPR_ICCB", "MT_THUNDER", "S_THUNDER"..i, "SPR_BOLT", "S_ZOOM" ,"SPR_ZOOM")
end

for i = 1, 7
freeslot("MT_MAGNET", "SPR_MAGN", "S_MAGNET", "S_MAGICPENTOGRAM1", "S_MAGICPENTOGRAM2", "SPR_PENT", "S_INSTASHIELD"..i, "SPR_INST")
end

mobjinfo[MT_ICECUBE] = {
	doomednum = 42,
	spawnstate = S_ICECUBE,
	spawnhealth = 5,
	painsound = sfx_iceb,
	deathsound = sfx_shattr,
	speed = 0,
	radius = 16*FRACUNIT,
	height = (40*3)*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_SOLID,
}

mobjinfo[MT_MAGNET] = {
	doomednum = -1,
	spawnstate = S_MAGNET,
	spawnhealth = 1,
	speed = 0,
	radius = 16*FRACUNIT,
	height = 40*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_NOGRAVITY,
}

mobjinfo[MT_THUNDER] = {
	doomednum = -1,
	spawnstate = S_THUNDER1,
	spawnhealth = 1,
	speed = 0,
	radius = 16*FRACUNIT,
	height = 100*FRACUNIT,
	dispoffset = 0,
	mass = 0,
	damage = 1,
	flags = MF_NOGRAVITY,
}

states[S_INSTASHIELD1] = {SPR_INST, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD2}
states[S_INSTASHIELD2] = {SPR_INST, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD3}
states[S_INSTASHIELD3] = {SPR_INST, C|FF_FULLBRIGHT, 4, nil, 0, 0, S_INSTASHIELD4}
states[S_INSTASHIELD4] = {SPR_INST, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_INSTASHIELD5}
states[S_INSTASHIELD5] = {SPR_INST, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD6}
states[S_INSTASHIELD6] = {SPR_INST, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD7}
states[S_INSTASHIELD7] = {SPR_INST, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_INSTASHIELD1}

states[S_MAGICSPARK1] = {SPR_MSPK, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK2}
states[S_MAGICSPARK2] = {SPR_MSPK, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK3}
states[S_MAGICSPARK3] = {SPR_MSPK, C|FF_FULLBRIGHT, 4, nil, 0, 0, S_MAGICSPARK4}
states[S_MAGICSPARK4] = {SPR_MSPK, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_MAGICSPARK5}
states[S_MAGICSPARK5] = {SPR_MSPK, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK6}
states[S_MAGICSPARK6] = {SPR_MSPK, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_MAGICSPARK7}
states[S_MAGICSPARK7] = {SPR_MSPK, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

states[S_MAGICPANEL1] = {SPR_MMTM, A|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL2] = {SPR_MMTM, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL3] = {SPR_MMTM, C|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL4] = {SPR_MMTM, D|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL5] = {SPR_MMTM, E|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL6] = {SPR_MMTM, F|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_MAGICPANEL7] = {SPR_MMTM, G|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}

states[S_ICECUBE] = {SPR_NULL, A, 2, nil, 0, 0, S_ICECUBE}

states[S_MAGNET] = {SPR_MAGN, A|FF_PAPERSPRITE, 2, nil, 0, 0, S_MAGNET}

states[S_ZOOM] = {SPR_ZOOM, A|FF_FULLBRIGHT|FF_PAPERSPRITE, 8, nil, 0, 0, S_NULL}

states[S_ICECUBEWALL1] = {SPR_ICCB, A|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_ICECUBEWALL2] = {SPR_ICCB, B|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_ICECUBEWALL3] = {SPR_ICCB, C|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_ICECUBEWALL4] = {SPR_ICCB, D|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}
states[S_ICECUBEWALL5] = {SPR_ICCB, E|FF_FULLBRIGHT|FF_PAPERSPRITE, 2, nil, 0, 0, S_NULL}

states[S_THUNDER1] = {SPR_BOLT, A|FF_FULLBRIGHT, 2, nil, 0, 0, S_THUNDER2}
states[S_THUNDER2] = {SPR_BOLT, B|FF_FULLBRIGHT, 2, nil, 0, 0, S_THUNDER3}
states[S_THUNDER3] = {SPR_BOLT, C|FF_FULLBRIGHT, 4, nil, 0, 0, S_THUNDER4}
states[S_THUNDER4] = {SPR_BOLT, D|FF_FULLBRIGHT, 3, nil, 0, 0, S_THUNDER5}
states[S_THUNDER5] = {SPR_BOLT, E|FF_FULLBRIGHT, 2, nil, 0, 0, S_THUNDER6}
states[S_THUNDER6] = {SPR_BOLT, F|FF_FULLBRIGHT, 2, nil, 0, 0, S_THUNDER7}
states[S_THUNDER7] = {SPR_BOLT, G|FF_FULLBRIGHT, 2, nil, 0, 0, S_NULL}

states[S_MAGICPENTOGRAM1] = {SPR_PENT, A|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS20, 50, nil, 1, 0, S_NULL}
states[S_MAGICPENTOGRAM2] = {SPR_PENT, B|FF_FULLBRIGHT|FF_PAPERSPRITE|FF_TRANS20, 50, nil, 0, 0, S_NULL}


freeslot("SKINCOLOR_MAGICALMETAL")

skincolors[SKINCOLOR_MAGICALMETAL] = {
	name = "Magical_Metal",
	ramp = {160,161,162,163,133,134,135,136,137,153,154,155,156,157,158,159},
    invcolor = SKINCOLOR_COBALT,
    invshade = 0,
    chatcolor = V_BLUEMAP,
    accessible = true
}	

local wallshatter = {
 [5] = S_ICECUBEWALL1,
 [4] = S_ICECUBEWALL2,
 [3] = S_ICECUBEWALL3,
 [2] = S_ICECUBEWALL4,
 [1] = S_ICECUBEWALL5}
 
addHook("MobjSpawn", function(mo)
	if mo
		for i = 1, 100
			local randomx = FixedMul(P_RandomRange(-25, 25)*FRACUNIT, sin(P_RandomRange(0, 360)*ANG1))
			local randomy = FixedMul(P_RandomRange(-25, 25)*FRACUNIT, cos(P_RandomRange(0, 360)*ANG1))
			local randomz = P_RandomRange(-5, (mo.height/FRACUNIT)+25)*FRACUNIT
			
			local snow = P_SpawnMobjFromMobj(mo, randomx, randomy, randomz, MT_SNOWFLAKE)
			snow.fuse = 15
		end
	end
end, MT_ICECUBE)

addHook("MobjThinker", function(mo)
	if mo
		if mo.z < mo.floorz
			P_SetObjectMomZ(mo, FRACUNIT*2, true)
		else
			P_SetObjectMomZ(mo, -FRACUNIT*5, true)
		end
		if mo.tracer and mo.shatter > 98
			P_TeleportMove(mo.tracer, mo.tracer.x, mo.tracer.y, mo.z + mo.height + 35*FRACUNIT)
		end
		for i = 1, 4
			local ns = ANGLE_90*i
			local gotox = FixedMul(25*FRACUNIT, cos(ns))
			local gotoy = FixedMul(25*FRACUNIT, sin(ns))
			
			local icewall = P_SpawnMobjFromMobj(mo, gotox, gotoy, 0, MT_GFZFLOWER1)
			icewall.angle = ns+ANGLE_90
			icewall.state = wallshatter[mo.health]
			icewall.fuse = 2
			icewall.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			icewall.spriteyscale = FRACUNIT*3
		end
		local icewall = P_SpawnMobjFromMobj(mo, 0, 0, mo.height+35*FRACUNIT, MT_GFZFLOWER1)
		icewall.angle = 0
		icewall.spriteyoffset = -24*FRACUNIT
		icewall.flags2 = $|MF2_SPLAT
		icewall.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
		icewall.state = wallshatter[mo.health]
		icewall.fuse = 2
		icewall.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
		
		if mo.shatter
			mo.shatter = $ - 1
		end
		
		if mo.shatter == 80
		or mo.shatter == 60
		or mo.shatter == 40
		or mo.shatter == 20
			S_StartSound(mo, mo.info.painsound)
		end
		
		if mo.shatter > 60 and mo.shatter < 80
			mo.health = 4
		elseif mo.shatter > 40 and mo.shatter < 60
			mo.health = 3
		elseif mo.shatter > 20 and mo.shatter < 40
			mo.health = 2
		elseif mo.shatter and mo.shatter < 20
			mo.health = 1
		end
	end
end, MT_ICECUBE)

local function CubeDeath(mo)
	if mo
		S_StartSound(mo, sfx_shattr)
		for i = 1, 50
			local randomangle = P_RandomRange(0, 360)*ANG1
			local ice = P_SpawnMobjFromMobj(mo, 0, 0, P_RandomRange(0, mo.height/FRACUNIT)*FRACUNIT, MT_GFZDEBRIS)
			ice.state = S_SNOW1
			ice.fuse = P_RandomRange(5, 15)
			P_InstaThrust(ice, randomangle, P_RandomRange(1, 15)*FRACUNIT)
			P_SetObjectMomZ(ice, P_RandomRange(-5, 5)*FRACUNIT)
		end
	end
end

addHook("MobjDeath", CubeDeath, MT_ICECUBE)
addHook("MobjFuse", CubeDeath, MT_ICECUBE)